#include <stdio.h>
#include <sys/stat.h>
#include <unistd.h>
#include <time.h>
#include <math.h>
#include <sys/time.h>
#include <sys/types.h>
#include <string.h>


char blacky_ver_info[] = "BFTime v0.01c (c) Copyright 2001 Andreas Hofmeier";


main(argc, argv)
  int argc;
  char *argv[];
{
  struct stat _stat;
  unsigned long t_file, t_now, t_diff;
  double i, ganz, rest;
  int x;
  fd_set rfds;
  struct timeval tv;
  int nomonths = 0;

  i = 1;
  if ((argv[1] != NULL) && (strcasecmp(argv[1], "-nomonths") == 0)) {
    nomonths = 1;
    i++;
  } else {
    printf("You can use -nomonths to suppress the months in the calcualtion.\n");
  }

  if (stat(argv[(int)i], &_stat) < 0) {
    perror(argv[(int)i]);
  }
  puts(ctime(&_stat.st_mtime));


  if (0) {
    int i;
 nochmal:

    for (i = 61 + 16 /* month & week */; i > 0; i--) {
      printf("\b");
    }
  }

  t_file = _stat.st_mtime;
  time(&t_now);
  
  if (t_file < t_now) {
    printf("t = + ");
    t_diff = t_now - t_file;
  } else {
    printf("t = - ");
    t_diff = t_file - t_now;
  }

  i = (double) t_diff;

  // Years
  modf(i / (60 * 60 * 24 * /*365.25*/ 365.2422), &ganz);
  printf("%03d years  ", (int) ganz);
  i = i - (ganz * (60 * 60 * 24 * /*365.25*/ 365.2422));

  if (nomonths == 1) {

    // weeks
    modf(i / (60 * 60 * 24 * 7), &ganz);
    printf("%02d weeks  ", (int) ganz);
    i = i - (ganz * (60 * 60 * 24 * 7));

  } else {

    // (
    // month
    modf(i / (60 * 60 * 24 * 30.4375), &ganz);
    printf("%02d month  ", (int) ganz);
    i = i - (ganz * (60 * 60 * 24 * 30.4375));
    // weeks
    modf(i / (60 * 60 * 24 * 7), &ganz);
    printf("%02d weeks  ", (int) ganz);
    i = i - (ganz * (60 * 60 * 24 * 7));
    // )

  }

  // Days
  rest = modf(i / (60 * 60 * 24), &ganz);
  printf("%02d days  ", (int) ganz);
  i = i - (ganz * (60 * 60 * 24));

  // hours
  rest = modf(i / (60 * 60), &ganz);
  printf("%02d hours  ", (int) ganz);
  i = i - (ganz * (60 * 60));

  // minutes
  rest = modf(i / 60, &ganz);
  printf("%02d min  ", (int) ganz);
  i = i - (ganz * (60));

  // sec
  printf("%02d sec", (int) i);

  fflush(stdout);

  FD_ZERO(&rfds);
  FD_SET(0, &rfds);
  tv.tv_sec = 1;
  tv.tv_usec = 0;
  if (select(1, &rfds, NULL, NULL, &tv) == 1) {
    exit(0);
  }
  goto nochmal;

}
